// SharedPtr.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <memory>

using namespace std;
using namespace std::tr1;

void Foo()
{
	// Create a shared int 
	// (dynamically allocates an integer, 
	//  and provides automatic reference counting)
	auto sharedInt = make_shared<int>(123);

	// Share the integer with a secondShare
	// (increments the reference count)
	shared_ptr<int> secondShare(sharedInt);

	// Release the pointer to the first integer
	// (decrements the reference count)
	sharedInt = nullptr;

	// Verify the shared int is still alive
	cout << "secondShare = " << *secondShare << endl;

	// Shared int is automatically deallocated 
	// as secondShare falls out of scope and the reference
	// count falls to zero
}

int _tmain(int argc, _TCHAR* argv[])
{
	Foo();

	cin.get();

	return 0;
}

